/*
	$Id: EnumMember.java 170 2006-04-08 21:16:55Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
   ¤ΤΥФޤ϶ΤΥФΤenumΥФǤ

   Υ饹ɽФEnumФȸƤӤޤΥФοƤϹ¤
   Τޤ϶ΤǤ

   enummemberǤбޤ
*/
public class EnumMember extends CompoundMember {

    /**
       EnumФޤ

       @param gm 롼ץޥ͡
       @param parentName Ƥ̾
       @param elem enummember
    */
    public EnumMember(final GroupManager gm, final String parentName,
		      final Element elem) {
	super(parentName, elem);

	String implName;
	if (type.equals("enum")) {
	    implName = "@" + IDManager.getInstance().getUniqueID();
	    setDescType(type + " " + implName);
	} else if (type.startsWith("enum ")) {
	    int k = type.indexOf(' ');
	    implName = type.substring(k + 1).trim();
	} else {
	    throw new RuntimeException("value of type attribute '"
				       + type
				       + "' is invalid.");
	}
	setCompoundImpl(new CompoundImpl(gm, "enum", elem, implName,
					 getDescType()) {
	    protected String getTagName() {
		return Enum.TAG_NAME;
	    }
	    protected Components getComponents(final GroupManager gm,
					       final String descType,
					       final NodeList nodes) {
		return new Constants(gm, nodes);
	    }
	});
    }
}
